/// Vanilla Password Hashing or vanphash is a simple password generator based on hashing, it starts as a legacy alternative to Twik Android app.
library vanphash;

import 'package:vanphash/src/hasher.dart';
import 'package:vanphash/src/types.dart';

twik_password(String tag, String master_password, String secret_key,
int length, PasswordType password_type) {
	/// Password generator with legacy security directives compatible with Twik android app 
	if (master_password == '') {
		return '';
	}
	if (secret_key != null) {
		tag = twik_hasher(secret_key, tag, 24, PasswordType.special);
	}

	return twik_hasher(tag, master_password, length, password_type);
}

custom_password(String tag, String master_password, String secret_key,
int length, int min_upper_alphas, int min_lower_alphas, int min_digits,
int min_specials, int max_upper_alphas, int max_lower_alphas, int max_digits,
int max_specials) {
	/// Password generator with custom security directives
	if (master_password == '') {
		return '';
	}
	if (secret_key != null) {
		tag = custom_hasher(secret_key, tag, 24);
	}

	return custom_hasher(tag, master_password, length,
	min_upper_alphas:min_upper_alphas, min_lower_alphas:min_lower_alphas,
	min_digits:min_digits, min_specials:min_specials,
	max_upper_alphas:max_upper_alphas, max_lower_alphas:max_lower_alphas,
	max_digits:max_digits, max_specials:max_specials);
}

password(String tag, String master_password, String secret_key, int length) {
	/// Password generator with vanphash security directives
	return custom_password(tag, master_password, secret_key, length, 3, 3, 3,
	3, length, length, length, length);
}
