import 'package:vanphash/vanphash.dart';
import 'package:vanphash/src/types.dart';
import 'package:test/test.dart';

void main() {
  group('Vanilla Password Hashing Test:', () {

	String tag;
	String master_password;
	String secret_key;

    setUp(() {
		tag = 'tag';
		master_password = 'master-password';
		secret_key = 'secret-key';
    });

	test('generate password compatible with Twik security directives', () {
		var hashed_password = twik_password(tag, master_password, secret_key,15, PasswordType.special);
		expect(hashed_password, equals("Xydq/CsifOveYu3"));
	});

	test('generate password with vanphash directives', () {
		var hashed_password = password(tag, master_password, secret_key,15);
		expect(hashed_password, equals("XydqtC.\$fOveYu3"));
	});
/*
	test('custom_password(...) generates password with custom security directives', () {
		var hashed_password = twik_password(tag, master_password, secret_key,15, PasswordType.special);
		expect(hashed_password, equals("Xydq/CsifOveYu3"));
	});
*/
	test('without master_key returns empty string', () {
		var hashed_password = password(tag, '', secret_key,15);
		expect(hashed_password, equals(''));
	});
  });
}
